//CSE 124C Section 4 Lab 9, Haibei Zhang
//BSTree.cpp

#include "BSTree.h"

//public---return the root
BSTnode<Lab9_DataClass> * BSTree::getRoot() const
{
	return root;
}

//private---build a new node
BSTnode<Lab9_DataClass> * BSTree::getTreeNode(const Lab9_DataClass item, BSTnode<Lab9_DataClass> * lptr, BSTnode<Lab9_DataClass> * rptr)
{
	BSTnode<Lab9_DataClass> * newnode;
	newnode=new BSTnode<Lab9_DataClass>(item, lptr, rptr);
	return newnode;
}

//private---the recursive method for copy constructor BSTree() and = operator
BSTnode<Lab9_DataClass> * BSTree::copyHelper(const BSTnode<Lab9_DataClass> * sourceNode)
{
	BSTnode<Lab9_DataClass> * newL, * newR, * newNode;
	if(sourceNode==NULL) return NULL;

	if(sourceNode->left!=NULL)
		newL=copyHelper(sourceNode->left);
	else
		newL=NULL;

	if(sourceNode->right!=NULL)
		newR=copyHelper(sourceNode->right);
	else
		newR=NULL;

	newNode=getTreeNode(sourceNode->nodeValue, newL, newR);
	return newNode;
}

//public---the default constructor
BSTree::BSTree()
{
	root=NULL;
}

//public---the copy constructor
BSTree::BSTree(const BSTree & sourceTree)
{
	root=copyHelper(sourceTree.getRoot());
}

//private---the recursive method for ~BSTree() and = operator
void BSTree::deleteHelper(BSTnode<Lab9_DataClass> * subtree)
{
	if(subtree!=NULL)
	{
		deleteHelper(subtree->left);
		deleteHelper(subtree->right);
		delete subtree;
	}
}

//public---the destructor
BSTree::~BSTree()
{
	deleteHelper(root);
}

//public---overload assignment operator =
BSTree& BSTree::operator = (const BSTree & rhs)
{
	if(this==&rhs)
		return *this;

	deleteHelper(root);
	root=copyHelper(rhs.getRoot());
	return *this;
}

//public---insert a node
void BSTree::insert(Lab9_DataClass & item)
{
	BSTnode<Lab9_DataClass> * temp=root, * parent=NULL, * newNode;
	while(temp)
	{
		parent=temp;
		if(item.GetData() < temp->nodeValue.GetData())
			temp=temp->left;
		else if(item.GetData() > temp->nodeValue.GetData())
			temp=temp->right;
		else
		{
			temp->nodeValue.IncCnt();
			return;
		}
	}

	newNode=getTreeNode(item, NULL, NULL);

	if(parent==NULL) 
		root=newNode;
	else if (item.GetData() < parent->nodeValue.GetData())
		parent->left=newNode;
	else
		parent->right=newNode;
}


//private---the recursive method for count()
int BSTree::countHelper(BSTnode<Lab9_DataClass> * subtree)
{
	return subtree?
			countHelper(subtree->left)+countHelper(subtree->right)+1
			:
			0;
}

//public---count()
int BSTree::count()
{
	return countHelper(root);
}


//private---the recursive method for depth()
int BSTree::depthHelper(BSTnode<Lab9_DataClass> * subtree)
{
	return subtree?
			(
				depthHelper(subtree->left) > depthHelper(subtree->right)?
					depthHelper(subtree->left)
					:
					depthHelper(subtree->right)
			)+1
			:
			0;
}

//public---depth()
int BSTree::depth()
{
	return depthHelper(root)-1;
}


//private---the recursive method (In-Order traversal) for print()
void BSTree::printHelper(BSTnode<Lab9_DataClass> * subtree, ostream & ostr)
{
	if(subtree)
	{
		printHelper(subtree->left, ostr);
		subtree->nodeValue.print(ostr);
		printHelper(subtree->right,ostr);
	}
}

//public---print()
void BSTree::print(ostream & ostr)
{
	printHelper(root, ostr);
}