//CSE 124C Section 4 Lab 9, Haibei Zhang
//BSTree.h

#ifndef BSTREE_H
#define BSTREE_H

#include "BSTnode.h"
#include "DataClass.h"

class BSTree
{
	private:
		BSTnode<Lab9_DataClass> *root;

		//build a new node
		BSTnode<Lab9_DataClass> * getTreeNode(const Lab9_DataClass item, BSTnode<Lab9_DataClass> * lptr=NULL, BSTnode<Lab9_DataClass> * rptr=NULL);
		
		//the recursive method for copy constructor BSTree() and = operator
		BSTnode<Lab9_DataClass> * copyHelper(const BSTnode<Lab9_DataClass> * sourceNode);

		//the recursive method for ~BSTree() and = operator
		void deleteHelper(BSTnode<Lab9_DataClass> * subtree);

		//the recursive method for count()
		int countHelper(BSTnode<Lab9_DataClass> * subtree);

		//the recursive method for depth()
		int depthHelper(BSTnode<Lab9_DataClass> * subtree);

		//the recursive method (In-Order traversal) for print()
		void printHelper(BSTnode<Lab9_DataClass> * subtree, ostream & ostr);

	public:
		//return the root
		BSTnode<Lab9_DataClass> * getRoot() const;

		//default constructor
		BSTree();

		//copy constructor, using copyHelper()
		BSTree(const BSTree & sourceTree);

		//destructor, using deleteHelper()
		~BSTree();

		//overload assignment operator, using deleteHelper() and copyHelper()
		BSTree& operator = (const BSTree & rhs);

		//insert a node
		void insert(Lab9_DataClass & item);

		//return the depth of the tree, using depthHelper()
		int depth();

		//return the number of nodes, using countHelper()
		int count();

		//print the tree, using printHelper()
		void print(ostream & ostr);
};

#endif //BSTREE_H