//CSE 124C Section 4 Lab 9, Haibei Zhang
//main.cpp

#include "BSTree.h"

int main()
{
	
//===============The main client program===============
	BSTree mytree; 
	
	ifstream in("input.txt");
	ofstream out("output.txt");

	string oneline; //temporary string to hold each word from instream
	Lab9_DataClass *tempdata; //temporary tree node object to be inserted
	
	while (in)  //while the instream does not reach the end
	{
		getline(in,oneline);
		if(oneline!="")
		{
			//build the node to be inserted
			tempdata=new Lab9_DataClass();
			tempdata->SetData(oneline);
			tempdata->SetCnt(1);

			//insert the node
			mytree.insert(*tempdata);
		}
	}
	in.close();
	
	out<<"The number of unique words in the text (count) is:     "<<mytree.count()<<endl;
	
	out<<"The depth of mytree is:     "<<mytree.depth()<<endl;
	
	out<<"mytree in alphabetic order:    ";
	mytree.print(out);
	out.close();

	
//===============The test program===============
	//a simpler tree is to be built as follows:
	//					i(1)
	//			f(1)			o(3)
	//		b(1)	h(1)	n(2)	y(1)
	//			e(2)
	//		d(1)
	//whose depth() should be 4 and count() should be 9
	
	//The testtree will be built from test_input.txt
	BSTree testtree; 
	
	ifstream testin("test_input.txt");
	ofstream testout("test_output.txt");

	while (testin)  //while the instream does not reach the end
	{
		getline(testin,oneline);
		if(oneline!="")
		{
			//build the node to be inserted
			tempdata=new Lab9_DataClass();
			tempdata->SetData(oneline);
			tempdata->SetCnt(1);

			//insert the node
			testtree.insert(*tempdata);
		}
	}
	testout<<"testtree constructed from test_input.txt"<<endl;
	testin.close();
	
	//Test count(), depth(), and the tree structure (by print()) of testtree
	testout<<"The count of testtree is:     "<<testtree.count()<<endl;
	testout<<"The depth of testtree is:     "<<testtree.depth()<<endl;
	testout<<"testtree in alphabetic order:    ";
	testtree.print(testout);



	//The testtree_copy is constructed by the copy constructor
	BSTree testtree_copy(testtree);
	testout<<endl<<endl<<"testtree_copy constructed"<<endl;

	//Test count(), depth(), and the tree structure (by print()) of testtree_copy
	testout<<"The count of testtree_copy is:     "<<testtree_copy.count()<<endl;
	testout<<"The depth of testtree_copy is:     "<<testtree_copy.depth()<<endl;
	testout<<"testtree_copy in alphabetic order:    ";
	testtree_copy.print(testout);



	//The testtree_assign is constructed by the overloaded assignment operator
	BSTree testtree_assign;
	testtree_assign=testtree;
	testout<<endl<<endl<<"testtree_assign assigned from testtree"<<endl;

	//Test count(), depth(), and the tree structure (by print()) of testtree_assign
	testout<<"The count of testtree_assign is:     "<<testtree_assign.count()<<endl;
	testout<<"The depth of testtree_assign is:     "<<testtree_assign.depth()<<endl;
	testout<<"testtree_assign in alphabetic order:    ";
	testtree_assign.print(testout);

	testout.close();


	return 0;
}

